"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.AlexaSession = void 0;
var uuid = require("uuid");
var AlexaSession = (function () {
    function AlexaSession() {
        this._id = "SessionID." + uuid.v4();
        this._new = true;
        this._attributes = {};
    }
    AlexaSession.prototype.attributes = function () {
        return this._attributes;
    };
    AlexaSession.prototype.updateAttributes = function (sessionAttributes) {
        if (sessionAttributes !== undefined && sessionAttributes !== null) {
            this._attributes = sessionAttributes;
        }
    };
    AlexaSession.prototype.id = function () {
        return this._id;
    };
    AlexaSession.prototype.setID = function (id) {
        this._id = id;
    };
    AlexaSession.prototype.isNew = function () {
        return this._new;
    };
    AlexaSession.prototype.used = function () {
        this._new = false;
    };
    return AlexaSession;
}());
exports.AlexaSession = AlexaSession;
//# sourceMappingURL=alexa-session.js.map