export declare class SampleUtterances {
    samples: {
        [id: string]: Array<string>;
    };
    constructor();
    static fromFile(file: string, callback: (sampleUtterances: SampleUtterances, error?: string) => void): void;
    static fromJSON(sampleUtterancesJSON: any): SampleUtterances;
    defaultUtterance(): string;
    intentForUtterance(phraseString: string): UtteredIntent;
    hasIntent(intent: string): boolean;
    private parseFlatFile;
}
export declare class Phrase {
    phrase: string;
    slots: Array<string>;
    normalizedPhrase: string;
    constructor(phrase: string);
    normalizeSlots(utterance: string): void;
    matchesUtterance(otherPhraseString: string): boolean;
    matches(otherPhrase: Phrase): boolean;
}
export declare class UtteredIntent {
    intentName: string;
    utterance: string;
    matchedPhrase: Phrase;
    constructor(intentName: string, utterance: string, matchedPhrase: Phrase);
    slotCount(): number;
    slotName(index: number): string;
    slotValue(index: number): string;
    toJSON(): any;
}
