import { AlexaContext } from "./alexa-context";
export declare class RequestType {
    static IntentRequest: string;
    static LaunchRequest: string;
    static SessionEndedRequest: string;
    static AudioPlayerPlaybackFinished: string;
    static AudioPlayerPlaybackNearlyFinished: string;
    static AudioPlayerPlaybackStarted: string;
    static AudioPlayerPlaybackStopped: string;
}
export declare enum SessionEndedReason {
    ERROR = 0,
    EXCEEDED_MAX_REPROMPTS = 1,
    USER_INITIATED = 2
}
export declare class ServiceRequest {
    private context;
    private requestJSON;
    private requestType;
    constructor(context: AlexaContext);
    intentRequest(intentName: string): ServiceRequest;
    audioPlayerRequest(requestType: string, token: string, offsetInMilliseconds: number): ServiceRequest;
    launchRequest(): ServiceRequest;
    sessionEndedRequest(reason: SessionEndedReason, errorData?: any): ServiceRequest;
    withSlot(slotName: string, slotValue: string): ServiceRequest;
    requiresSession(): boolean;
    private baseRequest;
    private static timestamp;
    private static requestID;
    private includeSession;
    toJSON(): any;
}
