import { SocketHandler } from "../core/socket-handler";
import { NetworkErrorType } from "../core/global";
import { KeepAlive } from "./keep-alive";
export declare class BespokeClient {
    nodeID: string;
    private host;
    private port;
    private targetDomain;
    private targetPort;
    private secretKey?;
    onConnect: (error?: any) => void;
    onReconnect: (error?: any) => void;
    onError: (errorType: NetworkErrorType, message: string) => void;
    static RECONNECT_MAX_RETRIES: number;
    private keepAlive;
    private socketHandler;
    private shuttingDown;
    private reconnectRetries;
    constructor(nodeID: string, host: string, port: number, targetDomain: string, targetPort: number, secretKey?: string);
    attemptConnection(): void;
    connect(onConnect?: (error?: any) => void): void;
    protected newKeepAlive(handler: SocketHandler): KeepAlive;
    private onWebhookReceived;
    private connected;
    private messageReceived;
    shutdown(callback?: () => void): void;
}
