export declare enum ProxyType {
    GOOGLE_CLOUD_FUNCTION = 0,
    HTTP = 1,
    LAMBDA = 2
}
export declare class BSTProxy {
    proxyType: ProxyType;
    private bespokenClient;
    private functionServer;
    private lambdaServer;
    private proxySecretKey;
    private isSecure;
    private bespokenHost;
    private bespokenPort;
    private functionFile;
    private functionName;
    private httpPort;
    private httpDomain;
    constructor(proxyType: ProxyType);
    static http(targetPort: number): BSTProxy;
    static lambda(lambdaFile?: string, functionName?: string): BSTProxy;
    static cloudFunction(functionFile: string, functionName?: string): BSTProxy;
    bespokenServer(host: string, port: number): BSTProxy;
    targetDomain(host: string): BSTProxy;
    secretKey(secretKey: string): BSTProxy;
    activateSecurity(): void;
    port(port: number): BSTProxy;
    startWithConfig(onStarted?: (error?: any) => void): BSTProxy;
    start(onStarted?: (error?: any) => void): void;
    stop(onStopped?: () => void): void;
}
