/// <reference types="node" />
import { Socket } from "net";
export declare class WebhookRequest {
    sourceSocket?: Socket;
    rawContents: Buffer;
    method: string;
    uri: string;
    body: string;
    rawBody: Buffer;
    queryParameters: {
        [id: string]: string | string[];
    };
    headers: {
        [id: string]: string;
    };
    private requestID;
    constructor(sourceSocket?: Socket);
    static fromBuffer(sourceSocket: Socket, payload: Buffer, id?: number): WebhookRequest;
    append(data: Buffer): void;
    appendBody(bodyPart: Buffer): void;
    done(): boolean;
    contentLength(): number;
    isPing(): boolean;
    private parseHeaders;
    nodeID(): string;
    private removeBespokenQueries;
    requestWithoutBespokenData(): Buffer;
    isJSON(): boolean;
    toString(): string;
    id(): number;
}
